# $Revision: 1.52.2.27 $, $Date: 2008/07/03 13:45:03 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace module
%bcond_with	verbose		# verbose build (V=1)

%ifarch sparc
%undefine	with_smp
%endif

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		iptables_ver	1.3.3
%define		pname	ipp2p
%define		rel		66
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl.UTF-8):	IPP2P - rozszerzenie filtra pakietów identyfikujące ruch P2P
Name:		%{pname}%{_alt_kernel}
Version:	0.8.2
Release:	%{rel}
Epoch:		1
License:	GPL
Group:		Base/Kernel
Source0:	http://www.ipp2p.org/downloads/%{pname}-%{version}.tar.gz
# Source0-md5:	9dd745830f302d70d0b728013c1d6a0c
Patch0:		%{pname}-2.6.19.patch
Patch1:		%{pname}-2.6.21.patch
URL:		http://www.ipp2p.org/
%{?with_userspace:BuildRequires:	iptables-devel >= 1.3.3}
%if %{with kernel}
%if %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.20.2
%endif
%endif
BuildRequires:	rpmbuild(macros) >= 1.452
BuildRequires:	sed >= 4.0
Buildroot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

%description -l pl.UTF-8
IPP2P to rozszerzenie netfiltra służące do identyfikowania ruchu
związanego z dzieleniem plików P2P. Głównym celem tworzenia IPP2P jest
udostępnienie administratorowi dynamicznego narzędzia do filtrowania
ruchu w inteligentny sposób. Nie jest nim zablokowanie całego ruchu
P2P, ale umożliwienie ograniczenia tego ruchu do danej przepustowości.
W tym celu IPP2P przeszukuje zawartość (payload) pakietów TCP pod
kątem wzorców sygnalizujących sieci P2P. Jeśli tych wzorców nie ma w
pakietach, muszą być użyte inne rozszerzenia netfiltra, aby IPP2P
działało zgodnie z opisem. IPP2P współpracuje ze śledzeniem oraz
znakowaniem połączeń - w ten sposób można wychwycić większą część
pakietów P2P i ograniczyć wykorzystanie łącza przez nie.

%package -n kernel%{_alt_kernel}-net-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl.UTF-8):	IPP2P - rozszerzenie filtra pakietów identyfikujące ruch P2P
Release:	%{rel}@%{_kernel_vermagic}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}(vermagic) = %{_kernel_ver}}
Obsoletes:	kernel%{_alt_kernel}-smp-net-ipp2p

%description -n kernel%{_alt_kernel}-net-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains Linux kernel module.

%description -n kernel%{_alt_kernel}-net-ipp2p -l pl.UTF-8
IPP2P to rozszerzenie netfiltra służące do identyfikowania ruchu
związanego z dzieleniem plików P2P. Głównym celem tworzenia IPP2P jest
udostępnienie administratorowi dynamicznego narzędzia do filtrowania
ruchu w inteligentny sposób. Nie jest nim zablokowanie całego ruchu
P2P, ale umożliwienie ograniczenia tego ruchu do danej przepustowości.
W tym celu IPP2P przeszukuje zawartość (payload) pakietów TCP pod
kątem wzorców sygnalizujących sieci P2P. Jeśli tych wzorców nie ma w
pakietach, muszą być użyte inne rozszerzenia netfiltra, aby IPP2P
działało zgodnie z opisem. IPP2P współpracuje ze śledzeniem oraz
znakowaniem połączeń - w ten sposób można wychwycić większą część
pakietów P2P i ograniczyć wykorzystanie łącza przez nie.

Ten pakiet zawiera moduł jądra Linuksa.

%package -n iptables-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl.UTF-8):	IPP2P - rozszerzenie filtra pakietów identyfikujące ruch P2P
Release:	%{rel}
Group:		Base/Kernel
Requires:	iptables

%description -n iptables-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains iptables module needed to control IPP2P kernel
module.

%description -n iptables-ipp2p -l pl.UTF-8
IPP2P to rozszerzenie netfiltra służące do identyfikowania ruchu
związanego z dzieleniem plików P2P. Głównym celem tworzenia IPP2P jest
udostępnienie administratorowi dynamicznego narzędzia do filtrowania
ruchu w inteligentny sposób. Nie jest nim zablokowanie całego ruchu
P2P, ale umożliwienie ograniczenia tego ruchu do danej przepustowości.
W tym celu IPP2P przeszukuje zawartość (payload) pakietów TCP pod
kątem wzorców sygnalizujących sieci P2P. Jeśli tych wzorców nie ma w
pakietach, muszą być użyte inne rozszerzenia netfiltra, aby IPP2P
działało zgodnie z opisem. IPP2P współpracuje ze śledzeniem oraz
znakowaniem połączeń - w ten sposób można wychwycić większą część
pakietów P2P i ograniczyć wykorzystanie łącza przez nie.

Ten pakiet zawiera moduł iptables potrzebny do sterowania modułem
jądra IPP2P.

%prep
%setup -q
sed -i "s:shell iptables:shell %{_sbindir}/iptables:" Makefile
%patch0 -p1
%patch1 -p1

%build
%if %{with userspace}
%{__cc} %{rpmcflags} -DIPTABLES_VERSION='"%{iptables_ver}"' -fPIC -c libipt_ipp2p.c
#%{__cc} %{rpmldflags} -shared libipt_ipp2p.o -o libipt_ipp2p.so
# using CC issues:
#libipt_ipp2p.o(.text+0x720): In function `_init':
#libipt_ipp2p.c: multiple definition of `_init'
#/usr/lib/gcc-lib/i686-pld-linux/3.3.6/../../../crti.o(.init+0x0):/home/users/builder/rpm/BUILD/glibc-2.3.6/builddir/csu/crti.S:12: first defined here
%{__ld} %(echo %{rpmldflags} | sed -e 's/-Wl,\([^ ]*\)/\1/g') -shared -o libipt_ipp2p.so libipt_ipp2p.o
%endif

%if %{with kernel}
# kernel module(s)
%build_kernel_modules -m ipt_%{pname}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_libdir}/iptables
install libipt_%{pname}.so $RPM_BUILD_ROOT%{_libdir}/iptables
%endif

%if %{with kernel}
%install_kernel_modules -m ipt_%{pname} -d kernel/net/ipv4/netfilter
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel%{_alt_kernel}-net-ipp2p
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-net-ipp2p
%depmod %{_kernel_ver}

%if %{with kernel}
%files -n kernel%{_alt_kernel}-net-ipp2p
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipt_%{pname}.ko*
%endif

%if %{with userspace}
%files -n iptables-ipp2p
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/iptables/*.so
%endif

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ipp2p.spec,v $
Revision 1.52.2.27  2008/07/03 13:45:03  glen
- merge from LINUX_2_6_22 branch, old one in LINUX_2_6_16 branch; rel 66

Revision 1.73.2.3  2008-04-04 19:37:12  glen
- release 65

Revision 1.73.2.2  2008-04-04 18:52:17  glen
- keep up with ac releases

Revision 1.73.2.1  2008-04-04 18:43:34  glen
- ac kernel macros

Revision 1.73  2008-04-03 20:52:19  glen
- alt kernel fixes from AC-branch

Revision 1.72  2008-03-27 20:56:04  glen
- rel 14 (2.6.22.19-5)

Revision 1.71  2008-03-13 20:20:53  arekm
- release 13

Revision 1.70  2008-02-15 14:14:41  glen
- use %{rpmldflags} instead of hardcoding ld --as-needed

Revision 1.69  2008-02-11 13:00:44  arekm
- rel 12

Revision 1.68  2008-01-22 22:53:40  glen
- rel 11 (2.6.16.59-2)

Revision 1.67  2007-12-17 14:17:43  arekm
- rel 11

Revision 1.66  2007-12-15 11:57:27  arekm
- rel 10

Revision 1.65  2007-11-29 08:01:42  arekm
- rel 9

Revision 1.64  2007-11-25 10:33:36  arekm
- rel 8

Revision 1.63  2007-10-24 09:46:54  arekm
- rel 7

Revision 1.62  2007/10/24 09:35:24  zbyniu
- added patch for kernels 2.6.21 .22

Revision 1.61  2007/10/12 12:48:52  arekm
- rel 6

Revision 1.60  2007/06/08 21:41:49  arekm
- rel 5

Revision 1.59  2007/04/12 15:16:42  shadzik
- proper kernel-module-build version

Revision 1.58  2007/03/25 16:06:55  shadzik
- use new kernel macros
- fix --as-needed (thx japhy)
- remove smp stuff and bconds ('up' too)

Revision 1.57  2007/03/15 23:01:58  glen
- up bcond

Revision 1.56  2007/02/21 08:50:31  mguevara
- api change in checkentry was in 2.6.19 not .17, sorry

Revision 1.55  2007/02/21 08:46:21  mguevara
- rel 4, added patch ipp2p-2.6.17.patch for api change in checkentry

Revision 1.54  2007/02/13 08:06:35  glen
- tabs in preamble

Revision 1.53  2007/02/12 00:48:57  baggins
- converted to UTF-8

Revision 1.52  2007/01/23 18:28:05  hawk
- release 3

Revision 1.51  2006/12/08 13:35:47  hawk
- reverted "use gcc for linking (we have -Wl, in ldflags)" from previous
  revision, breaks build
- workaround for builder automation to allow building against
  kernel-grsecurity (via bcond)
- release 2

Revision 1.50  2006/11/23 21:55:50  sparky
- use %build_kernel_modules and %install_kernel_modules
- use gcc for linking (we have -Wl, in ldflags)

Revision 1.49  2006/11/23 20:14:46  hawk
- update to 0.8.2

Revision 1.48  2006/11/23 19:28:10  adamg
- BuildRequires: rpmbuild(macros) >= 1.308 (alt_kernel support)

Revision 1.47  2006/11/23 19:04:12  hawk
- alt_kernel support
- release 5

Revision 1.46  2006/09/06 13:48:33  sparky
- mass atack: -j1 for make scripts

Revision 1.45  2006/07/02 15:44:24  hawk
- release 4

Revision 1.44  2006/04/12 11:34:09  glen
- tabs

Revision 1.43  2006/04/12 11:31:16  glen
- kernel epoch, fix %prep

Revision 1.42  2006/02/24 18:38:13  qboosh
- rel 3

Revision 1.41  2006/02/24 00:12:11  arekm
- sparc fix

Revision 1.40  2006/02/24 00:09:13  arekm
- new building way

Revision 1.39  2006/01/05 20:51:06  dzeus
- up to 0.8.1_rc1

Revision 1.38  2005/11/27 18:58:24  arekm
- rel 3

Revision 1.37  2005/11/13 02:15:15  sparky
- if there is no asm-powerpc link asm-ppc !
- spaces->tabs

Revision 1.36  2005/11/12 11:46:28  arekm
- rel 2

Revision 1.35  2005/10/21 20:22:23  dzeus
- up to final 0.8.0, cleanup

Revision 1.34  2005/09/17 03:16:21  wolvverine
- md5

Revision 1.33  2005/09/17 03:12:58  wolvverine
- up to 0.8.0_rc3

Revision 1.32  2005/09/15 18:25:05  sparky
- prepared for kernel >= 2.6.13: link Module.symvers

Revision 1.31  2005/05/22 10:22:41  averne
- rel 2

Revision 1.30  2005/05/15 17:32:16  qboosh
- use __cc

Revision 1.29  2005/05/14 11:40:02  kosmo
- fixed userspace build
- now iptables loads builded module

Revision 1.28  2005/03/23 12:10:09  andree
- updated to 0.7.4 (snap but builds on 2.6.11)
- updated url

Revision 1.27  2005/01/21 07:23:42  kosmo
- updated to 0.7.1

Revision 1.26  2004/12/30 01:42:01  pluto
- updated to 0.7 (thx Tomasz Kolaj).

Revision 1.25  2004/10/19 17:02:31  havner
- rel 5

Revision 1.24  2004/09/01 16:11:10  adamg
- kill pld.org.pl leftovers

Revision 1.23  2004/08/31 15:52:46  snurf
- typos / formatting / etc.

Revision 1.22  2004/08/08 17:55:17  havner
- rel 4

Revision 1.21  2004/07/29 13:35:45  havner
- rel 3 for rebuild

Revision 1.20  2004/07/29 13:06:10  averne
- rel2 for rebuild with proper iptables-devel

Revision 1.19  2004/07/22 19:15:07  qboosh
- Name changed to ipp2p, kernel-net-ipp2p.spec renamed to ipp2p.spec
- up module to subpackage, fixed smp depmods

Revision 1.18  2004/07/13 16:53:15  pluto
- BR(kernel-module-build) fixed.

Revision 1.17  2004/07/08 21:18:18  pluto
- updated to 0.6.
  (--gnu for better matching of Shareaza
   --edk new eMule and Kademlia patterns).

Revision 1.16  2004/07/03 21:05:17  pluto
- netfilter version = 1.2.11

Revision 1.15  2004/06/29 22:34:25  gotar
- s/filtru/filtra/

Revision 1.14  2004/05/30 18:07:42  pluto
- 2.6.7+ complaint.
- release 2.

Revision 1.13  2004/04/29 18:19:02  pluto
- netfilter version updated.

Revision 1.12  2004/04/08 11:35:36  pluto
- 2.6.5 fixes.

Revision 1.11  2004/03/16 09:51:59  qboosh
- removed empty post/postun for iptables module

Revision 1.10  2004/03/15 00:05:37  pluto
- updated to 0.5c.
  new option: --soul for SoulSeek (DROP only).
  extension: --kazaa also matches iMesh packets now.

  note that SoulSeek opens a new TCP connection for every download.
  We can not recognize this connection so marking does not work.
  But we can detect CONNECT and TRANSFER REQUEST packets so a DROP
  rule will make Soulseek stop working.

Revision 1.9  2004/03/14 18:40:53  pluto
- fixed INCPATH.

Revision 1.8  2004/03/14 17:34:37  pluto
- s/%{_kernel_ver_str}/%{_kernel_ver}/

Revision 1.7  2004/03/11 12:51:57  pluto
- fixed build with non-dist kernel.
- release 2.

Revision 1.6  2004/03/11 10:47:55  qboosh
- fixed build with dist_kernel once again

Revision 1.5  2004/03/10 18:58:58  pluto
- removed redudant symlinks {asm,autoconf.h}.
- multiconf build (up{,smp} xor nondist).

Revision 1.4  2004/03/10 16:19:25  qboosh
- fixed autoconf.h issue with distro kernel
- still waiting for pluto to fix both UP+SMP build

Revision 1.3  2004/03/04 19:08:55  qboosh
- merged fixes from HEAD and LINUX_2_6, cleanups, pl, kernel/userspace bconds

Revision 1.2  2004/03/03 22:39:46  ankry
- some typos, md5, fixed Group

Revision 1.1.2.8  2004/03/04 02:51:15  pluto
- drivers/net -> net/ipv4/netfilter

Revision 1.1.2.7  2004/03/04 01:51:05  pluto
- fixed cflags.

Revision 1.1.2.6  2004/03/03 22:37:57  pluto
- %desc, NFY...

Revision 1.1.2.5  2004/03/03 21:57:31  pluto
- fixed %build, %install, %files

Revision 1.1.2.4  2004/03/03 09:13:25  cieciwa
- fixed %build, %install, %files,
- %description and %summary not updated.

Revision 1.1.2.3  2004/03/03 08:32:26  cieciwa
- updated

Revision 1.1.2.2  2004/03/03 08:22:54  cieciwa
- updated

Revision 1.1.2.1  2004/03/03 08:17:31  cieciwa
- working on

Revision 1.1  2004/03/03 07:37:21  cieciwa
- initial
